#!/bin/awk -f
#
# grind song-by-artist index from name-map and name-list.
#
# name-map comes first in the form:
#   canonical-name:human-readable-name
# examples:
#   artist:Artist Name
#   artist/album:Album Title
#   artist/album/song:Song Title
#
# then name-list in the form:
#   sort-key^Icanonical-name
# examples:
#   Last, First^Iartist
#   Last, First^Iartist/album
#   Last, First^Iartist/album/song.mp3
#

BEGIN {
    level=0
    art=""
    alb=""
    lastalf="@"
    ucmap="@ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    lcmap="@abcdefghijklmnopqrstuvwxyz"
}

# old style tag file with just name
/^[^:]*:[^:=]*$/ {
    split($0,a,":")
    namemap[a[1]]=a[2]
}

/:N=/ {
    split($0,a,":")
    i=index($0,"=")
    namemap[a[1]]=substr($0,i+1)
}

/:T=/ {
    split($0,a,":")
    i=index($0,"=")
    timemap[a[1]]=substr($0,i+1)
}

/:DATE=/ {
    split($0,a,":")
    i=index($0,"=")
    datemap[a[1]]=substr($0,i+1)
}

$1 == "@" {
}

!/:/ && !/@/ && (!/\./ || /\.mp3$/) {
    canon=$NF
    names=$NF
    if (names ~ /\.mp3$/) {
	names=substr(names, 1, length(names)-4)
    }
    nel=split(names,a,"/");
    aa[1]=a[1]
    for (i = 2; i <= nel; i++) {
	aa[i]=aa[i-1] "/" a[i]
    }
    name=a[nel]
    if (namemap[names] != "") {
	name=namemap[names];
    }
    n=2
    if (art != a[nel-2]) {
	n = 0
    } else {
	if (alb != a[nel-1]) {
	    n = 1
	}
    }
    while (level > n) {
	if (level == 2) {
	    print "</table>"
	}
	if (level == 1) {
	    print "</ul>"
	}
	level--
    }
    n=2
    while (level < n) {
	level++
	if (level == 1) {
	    if (namemap[aa[nel-2]] != "") {
		b=namemap[aa[nel-2]]
	    } else {
		b=a[nel-2]
	    }
    alf=substr($1,1,1)
    i=index(lcmap,alf)
    if (i > 1) {
	alf=substr(ucmap,i,1)
    }
    while (lastalf < alf) {
	lastalf=substr(ucmap,index(ucmap,lastalf)+1,1)
	print "<a name=\"" lastalf "\">"
    }
	    print "<a name=\"" b "\">"
	    print "<table width=50%>"
	    print "<tr><td align=left><p><font size=+2>" b "</font></td>"
	    print "<td align=right><a href=\"#TOPOFILE\">"
	    print "<img src=\"/rfm/up.gif\" alt=\"to Top\" border=0></a></td>"
	    print "</tr>"
	    print "</table>"
	    print "<ul>"
	}
	if (level == 2) {
	    if (namemap[aa[nel-1]] != "") {
		b=namemap[aa[nel-1]]
	    } else {
		b=a[nel-1]
	    }
	    print "<li><b>" b "</b>"
	    if (datemap[aa[nel-1]] != "") {
		print "<br><em>" datemap[aa[nel-1]] "</em>"
	    }
	    print "<table width=50% cellpadding=0>"
	}
    }
    time=timemap[names];
    print "<tr><td align=right><a href=\"/cgi-bin/tuneput.cgi?" canon "\">" name "</a></td><td width=25% align=center><a href=\"/cgi-bin/abouttrack.cgi?" canon "\">" time "</a></td></tr>"
    level=3
    art=a[nel-2]
    alb=a[nel-1]
}

END {
    n=1
    while (level > n) {
	if (level == 3) {
	    print "</table>"
	}
	if (level == 2) {
	    print "</ul>"
	}
	level--
    }
    alf="Z"
    while (lastalf < alf) {
	lastalf=substr(ucmap,index(ucmap,lastalf)+1,1)
	print "<a name=\"" lastalf "\">"
    }
}

