#!/usr/bin/perl

$tunebot_root=$ENV{"TUNEBOT_ROOT"};

sub suggestdir {
    my ($a) = @_;
    $a =~ tr/\xa2\xb5/cu/;
    $a =~ tr/\xc0\xc1\xc2\xc3\xc4\xc5\xc7\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd8\xd9\xda\xdb\xdc\xdd\xde/AAAAAACEEEEIIIIDNOOOOOOUUUUYP/;
    $a =~ tr/\xe0\xe1\xe2\xe3\xe4\xe5\xe7\xe8\xe9\xea\xeb\xec\xed\xee\xef\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff/aaaaaaceeeeiiiidnoooooouuuuypy/;
    $a =~ s/\xc6/AE/g;
    $a =~ s/\xe6/ae/g;
    $a =~ s/\xdf/ss/g;
    $a =~ tr/A-Z$/a-zs/;
    $a =~ tr/a-z0-9_/_/c;
    $a =~ s/__*/_/g;
    $a =~ s/^_*//;
    $a =~ s/_*$//;
    if ($a eq "") {
        $a=_;
    }
    return $a;
}

sub printartistalbum {
    $a=$l;
    $a =~ s/\/.*//;
    $b=$l;
    $b =~ s/^.*\///;
    $a=suggestdir($a);
    $b=suggestdir($b);
    print "$a/$b";
}

if ($#ARGV == -1 || ($#ARGV == 0 && $ARGV[0] eq "-?")) {
    print "usage: canname [ opts ] [ album_path ... ]\n";
    print "       canname [ opts ] -a\n";
    print "               -p  print absolute path too\n";
    print "               -s  print size in kbytes\n";
    exit 1
}

$doall=0;
$showpath=0;
$showsize=0;
for ($i = 0; $i <= $#ARGV; ++$i) {
    if ($ARGV[$i] eq "-a") {
	$doall=1;
    }
    if ($ARGV[$i] eq "-p") {
	$showpath=1;
    }
    if ($ARGV[$i] eq "-s") {
	$showsize=1;
    }
}

if ($doall) {
    open(I, $tunebot_root."/tune.autotags");
    while ($l = <I>) {
	if ($l =~ ":A_ALBUM=") {
	    chomp $l;
	    $p = $l;
	    $p =~ s/:A_ALBUM=.*//;
	    $l =~ s/^.*:A_ALBUM=//;
	    printartistalbum($l);
	    if ($showsize) {
		$s=` du -s $p `;
		chomp $s;
		$s =~ s/[ 	].*//;
		print " $s";
	    }
	    if ($showpath) {
		print " $p";
	    }
	    print "\n";
	}
    }
    close(I);
} else {
    open(I, $tunebot_root."/tune.autotags");
    while ($l = <I>) {
	if ($l =~ ":A_ALBUM=") {
	    chomp $l;
	    $p=$l;
	    $p =~ s/:A_ALBUM=.*//;
	    $y=0;
	    foreach $x (@ARGV) {
		if ($x eq $p) {
		    $y=1;
		    break;
		}
	    }
	    if ($y == 1) {
		$p = $l;
		$p =~ s/:A_ALBUM=.*//;
		$l =~ s/^.*:A_ALBUM=//;
		printartistalbum($l);
		if ($showsize) {
		    $s=` du -s $p `;
		    chomp $s;
		    $s =~ s/[ 	].*//;
		    print " $s";
		}
		if ($showpath) {
		    print " $p";
		}
		print "\n";
	    }
	}
    }
    close(I);
}

