#!/usr/bin/perl
#
# play album with some options
#
# imports:
#    environment:
#    TUNEBOT_ROOT    root of tunebot installation.
#    TUNEIX          index of tune files.
#    TUNETAGS        index of tune attributes.
#    BANNER_STRING   identifying string for web page titles
#    QUERY_STRING    string from the browser
#
#    files:
#       $TUNEBOT_ROOT/tune.autotags
#       $TUNEBOT_ROOT/html/bodypart.html.head
#       $TUNEBOT_ROOT/html/bodypart.html.tail
#

$tunebot_root=$ENV{TUNEBOT_ROOT};
$debug=0;

#
# take track name and render into nice format in html.
#
sub friendlytitle {
    my ($title) = $tags{@_, "N"};
    if ($title eq "") {
	$title = "<em>" . $title . "</em>";
    } else {
	$title = "<a alt=PlayIt href=\"/cgi-bin/tuneput.cgi?" . @_[0] . ".mp3\">" . $title . "</a>";
	my ($art) = $tags{@_, "ARTIST"};
	if ($art ne "") {
	    $title = $title . " <em>- " . $art . "</em>";
	}
	my ($b) = @_;
	my ($i) = rindex($b, "/");
	if ($i >= 0) {
	    $b = substr($b, 0, $i);
	}
	my ($a) = $b;
	$i = rindex($a, "/");
	if ($i >= 0) {
	    $a = substr($a, 0, $i);
	}
	$i = $tags{$a, "N"};
	if ($i ne "") {
#	    $title = $title . "<br><em>&nbsp;" . $i;
	    my $x = $autotags{$a, "H_ARTIST"};
	    my $y = $autotags{$a, "A_ARTIST"};
	    if ($x eq "" || $y eq "") {
		$title = $title . "<br><em>&nbsp;" . $i;
	    } else {
		$title = $title . "<br><em>&nbsp;<a href=\"/rfm/tunesbyartist" . $x . ".html#" . $y . "\">" . $i . "</a>";
	    }
	    $i = $tags{$b, "N"};
	    if ($i ne "") {
#		$title = $title . " / " . $i;
		my $z = $autotags{$b, "A_ALBUM"};
		if ($x eq "" || $z eq "") {
		    $title = $title . " / " . $i;
		} else {
		    $title = $title . " / <a href=\"/rfm/tunesbyartist" . $x . ".html#" . $z . "\">" . $i . "</a>";
		}
	    }
	    $title = $title . "</em>";
	}
    }
    return $title;
}

sub friendlyalbumtitle {
    my ($title) = "";
    my ($b) = @_;
    my ($a) = $b;
    my ($i) = rindex($a, "/");
    if ($i >= 0) {
	$a = substr($a, 0, $i);
    }
    my ($x) = $autotags{$a, "H_ARTIST"};
    my ($y) = $autotags{$a, "A_ARTIST"};
    my ($z) = $autotags{$b, "A_ALBUM"};
    $i = $tags{$b, "N"};
    if ($x eq "" || $z eq "") {
	$title = $i;
    } else {
	$title = "<a href=\"/rfm/tunesbyartist" . $x . ".html#" . $z . "\">" . $i . "</a>";
    }
    $i = $tags{$a, "N"};
    if ($i ne "") {
	if ($x eq "" || $y eq "") {
	    $title = $title . " - " . $i;
	} else {
	    $title = $title . " - <a href=\"/rfm/tunesbyartist" . $x . ".html#" . $y . "\">" . $i . "</a>";
	}
    }
    return $title;
}

sub gettime {
    my ($i) = $tags{@_, "T"};
    if ($i eq "") {
	$i = "?";
    }
    $i = "(" . $i . ")";
    return $i;
}

sub urldec {
    my ($a) = $_[0];
    my ($b) = "";
    $a =~ tr/+/ /;
    while ($a ne "") {
        my ($c) = substr($a, 0, 1);
        if ($c eq "%") {
            $b .= chr hex substr($a, 1, 2);
            $a =~ s/...//;
        } else {
            $b .= $c;
            $a =~ s/.//;
        }
    }
    return $b;
}

#
# read all track tags and auto-generated tags into a hash
#
sub suckintags {
    open(TUNETAGS, $ENV{TUNETAGS});
    while ($line = <TUNETAGS>) {
	chop $line;
	$i = index($line, ":");
	$j = index($line, "=", $i);
	$file = substr($line, 0, $i);
	$tag = substr($line, $i + 1, $j - $i - 1);
	$value = substr($line, $j + 1);
	$tags{$file, $tag} = $value;
    }
    close(TUNETAGS);
    open(AUTOTAGS, $ENV{TUNEBOT_ROOT} . "/tune.autotags");
    while ($line = <AUTOTAGS>) {
	chop $line;
	$i = index($line, ":");
	$j = index($line, "=", $i);
	$file = substr($line, 0, $i);
	$tag = substr($line, $i + 1, $j - $i - 1);
	$value = substr($line, $j + 1);
	$autotags{$file, $tag} = $value;
    }
    close(AUTOTAGS);
}

print "Content-type: text/html\n";
print "\n";

if ($debug > 0) {
    print "<p>\n";
    print "query string is: " . $ENV{QUERY_STRING} . "\n";
    print "<p>\n";
    print "i've got " . $#ARGV . " command args\n";
    for ($i = 0; $i <= $#ARGV; $i++) {
	print "<br>" . $i . ". " . @ARGV[$i] . "\n";
    }
    print "<p>\n";
    print "<hr>\n";
    print "<pre>\n";
}
#
# parse stdin into a list of name-value pairs and stuff into hash %posts.
# this is used to support the POST method.
# stdin format is "name1=value1&name2=value2&...".
#
while ($line = <>) {
    chop $line;
    @nvpairs = split('&', $line);
    for ($i = 0; $i <= $#nvpairs; $i++) {
	@nv = split('=',@nvpairs[$i]);
	if ($#nv == 1) {
	    if ($debug > 0) {
		print @nv[0] . "  =  " . @nv[1] . "\n";
	    }
	    $posts{@nv[0]} = @nv[1];
	}
    }
};
#
# parse QUERY_STRING into nv pairs and hash them.
# this supports the GET method (which is currently used).
#
@nvpairs = split('&', $ENV{QUERY_STRING});
for ($i = 0; $i <= $#nvpairs; $i++) {
    @nv = split('=',@nvpairs[$i]);
    if ($#nv == 1) {
	if ($debug > 0) {
	    print @nv[0] . "  =  " . @nv[1] . "\n";
	}
	$posts{@nv[0]} = @nv[1];
    }
}
if ($debug > 0) {
    print "</pre>\n";
    print "<hr>\n";
}

#
# read all track tags and auto-generated tags into a hash
#
open(TUNETAGS, $ENV{TUNETAGS});
while ($line = <TUNETAGS>) {
    chop $line;
    $i = index($line, ":");
    $j = index($line, "=", $i);
    $file = substr($line, 0, $i);
    $tag = substr($line, $i + 1, $j - $i - 1);
    $value = substr($line, $j + 1);
    $tags{$file, $tag} = $value;
}
close(TUNETAGS);
open(AUTOTAGS, $ENV{TUNEBOT_ROOT} . "/tune.autotags");
while ($line = <AUTOTAGS>) {
    chop $line;
    $i = index($line, ":");
    $j = index($line, "=", $i);
    $file = substr($line, 0, $i);
    $tag = substr($line, $i + 1, $j - $i - 1);
    $value = substr($line, $j + 1);
    $autotags{$file, $tag} = $value;
}
close(AUTOTAGS);

if ($posts{"commit"} ne "") {
    $album=urldec($posts{"album"});
#    print "<pre>\n";
#    print "album is $album \n";
    if ($posts{"all"} eq "") {
	$album=$album . ":";
	foreach $i (%posts) {
	    if ($i =~ /^t[0-9]/) {
		$i =~ s/^t//;
		$album=$album . $i . ",";
	    }
	}
    }
#    print $album . "\n";
#    print "</pre>\n";
    print "<html>\n";
    print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    print "<META HTTP-EQUIV=REFRESH CONTENT=\"0; URL=tuneput.cgi?album=" . $album . "\">";
    print "</html>\n";

} else {
    suckintags();
#
# render selection form.
#
    print "<html>\n";
    print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
    print "<head>\n";
    print "<title>" . $ENV{BANNER_STRING} . " Play Album</title>\n";
    print "</head>\n";
    open(I, $tunebot_root . "/html/bodypart.html.head");
    while ($line = <I>) {
	print $line;
    }
    close(I);
    print "<p>\n";
    print "<center><font size=+2><b>" . $ENV{BANNER_STRING} . " Play Album</b></font></center>\n";
    print "<p>\n";

    $album=$posts{"album"};
    if ($album ne "") {
	$album=urldec($album);
        print "<font size=+1><b>" . friendlyalbumtitle($album). "</b></font>\n<p>\n";
	$nt = 0;
	$l=length($album);
	open(TUNEIX, $ENV{TUNEIX});
	while ($line = <TUNEIX>) {
	    chop $line;
	    if (substr($line, 0, $l) eq $album) {
		$line =~ s/\.mp3$//;
		$tracks[$nt] = $line;
		$nt++;
	    }
	}
	close(TUNEIX);
	@tracks = sort(@tracks);
	print "<form action=\"/cgi-bin/playalbum.cgi\">\n";
	print "Select the tracks you want to play and hit the play button\n";
	print "<p>\n";
	print "<input type=hidden name=album value=$album>\n";
	print "<input type=hidden name=commit>\n";
	print "<table cellpadding=0 cellspacing=0 align=center width=90%>\n";
	print "<tr><td><input type=image border=0 align=middle src=\"/rfm/play.gif\" alt=\"Play\"></td></tr>\n";
	for ($i = 0; $i <= $#tracks; $i++) {
	    $t = $tracks[$i];
	    $t = $tags{$t, "N"};
	    print "<tr><td width=10%><input type=checkbox name=t", $i + 1, "></td>";
	    print "<td><font size=-1>", $i + 1, ". </font> ", $t, "</td></tr>\n";
	}
	print "<tr><td width=10%><input type=checkbox name=all></td>";
	print "<td>(play all tracks)</td></tr>\n";
	print "</table>\n";
	print "</form>\n";
    }
}

open(I, $tunebot_root . "/html/bodypart.html.tail");
while ($line = <I>) {
    print $line;
}
close(I);

print "</html>\n";
exit 0

