#!/usr/bin/perl
#
# enter a dedication for a request
#
# imports:
#    environment:
#    TUNEBOT_ROOT    root of tunebot installation.
#    QDIR            directory where requests and play history live.
#    BANNER_STRING   identifying string for web page titles
#
#    files:
#       $TUNEBOT_ROOT/tune.autotags
#       $TUNEBOT_ROOT/html/bodypart.html.head
#       $TUNEBOT_ROOT/html/bodypart.html.tail
#

$tunebot_root=$ENV{TUNEBOT_ROOT};
$q_directory=$ENV{QDIR};
$debug=0;

open(AUTOTAGS, $ENV{TUNEBOT_ROOT} . "/tune.autotags");
while ($line = <AUTOTAGS>) {
    chop $line;
    $i = index($line, ":");
    $j = index($line, "=", $i);
    $file = substr($line, 0, $i);
    $tag = substr($line, $i + 1, $j - $i - 1);
    $value = substr($line, $j + 1);
    $autotags{$file, $tag} = $value;
}
close(AUTOTAGS);

sub urldec {
    my ($a) = $_[0];
    my ($b) = "";
    $a =~ tr/+/ /;
    while ($a ne "") {
        my ($c) = substr($a, 0, 1);
        if ($c eq "%") {
            $b .= chr hex substr($a, 1, 2);
            $a =~ s/...//;
        } else {
            $b .= $c;
            $a =~ s/.//;
        }
    }
    return $b;
}

sub lookuptag {
    my ($a) = @_[0];
    my ($i) = index($a, "\.mp3");
    if ($i >= 0) {
	$a = substr($a, 0, $i);
    }
    my ($t) = "";
    if (open(F, $a . ".t")) {
	while ($i = <F>) {
	    chop $i;
	    if (substr($i, 0, length(@_[1])) eq @_[1]) {
		$t = substr($i, length(@_[1]));
		break;
	    }
	}
	close(F);
    } elsif (open(F, $a)) {
	while ($i = <F>) {
	    chop $i;
	    if (substr($i, 0, length(@_[1])) eq @_[1]) {
		$t = substr($i, length(@_[1]));
		break;
	    }
	}
	close(F);
    }
    return $t;
}

sub friendlytitle {
    my ($title) = lookuptag(@_, "N=");
    if ($title eq "") {
	$title = @_[0];
	$title =~ s/^.*\///;
	$title =~ s/\.mp3$//;
	$title = "<em>" . $title . "</em>";
    }
    my ($art) = lookuptag(@_, "ARTIST=");
    if ($art ne "") {
	$title = $title . " <em>- " . $art . "</em>";
    }
    my ($b) = @_;
    my ($i) = rindex($b, "/");
    if ($i >= 0) {
	$b = substr($b, 0, $i);
    }
    my ($a) = $b;
    $i = rindex($a, "/");
    if ($i >= 0) {
	$a = substr($a, 0, $i);
    }
    $i = lookuptag($a, "N=");
    if ($i eq "") {
	$i = $a;
	$i =~ s/\/$//;
	$i =~ s/^.*\///;
    }
    $x = $autotags{$a, "H_ARTIST"};
    $y = $autotags{$a, "A_ARTIST"};
    $z = $autotags{$b, "A_ALBUM"};
    if ($x eq "" || $y eq "") {
	$title = $title . "<br><em>&nbsp;" . $i;
    } else {
	$title = $title . "<br><em>&nbsp;<a href=\"/rfm/tunesbyartist" . $x . ".html#" . $y . "\">" . $i . "</a>";
    }
    $i = lookuptag($b, "N=");
    if ($i eq "") {
	$i = $b;
	$i =~ s/\/$//;
	$i =~ s/^.*\///;
    }
    if ($x eq "" || $z eq "") {
	$title = $title . " / " . $i;
    } else {
	$title = $title . " / <a href=\"/rfm/tunesbyartist" . $x . ".html#" . $z . "\">" . $i . "</a>";
    }
    $title = $title . "</em>";
    return $title;
}

sub friendlyalbumtitle {
    my ($title) = "";
    my ($b) = @_;
    my ($a) = $b;
    my ($i) = rindex($a, "/");
    if ($i >= 0) {
	$a = substr($a, 0, $i);
    }
    my ($x) = $autotags{$a, "H_ARTIST"};
    my ($y) = $autotags{$a, "A_ARTIST"};
    my ($z) = $autotags{$b, "A_ALBUM"};
    $i = lookuptag($b, "N=");
    if ($x eq "" || $z eq "") {
	$title = $i;
    } else {
	$title = "<a href=\"/rfm/tunesbyartist" . $x . ".html#" . $z . "\">" . $i . "</a>";
    }
    $i = lookuptag($a, "N=");
    if ($i ne "") {
	if ($x eq "" || $y eq "") {
	    $title = $title . " - " . $i;
	} else {
	    $title = $title . " - <a href=\"/rfm/tunesbyartist" . $x . ".html#" . $y . "\">" . $i . "</a>";
	}
    }
    return $title;
}

sub gettime {
    my ($i) = lookuptag(@_, "T=");
    if ($i eq "") {
	$i = "?";
    }
    $i = "(" . $i . ")";
    return $i;
}

print "Content-type: text/html\n";
print "\n";
print "<html>\n";
print "<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\n";
print "<head>\n";
print "<title>" . $ENV{BANNER_STRING} . " Edit Dedication</title>\n";
print "</head>\n";
open(I, $tunebot_root . "/html/bodypart.html.head");
while ($line = <I>) {
    print $line;
}
close(I);
print "<center><font size=+2><b>" . $ENV{BANNER_STRING} . " Dedication</b></font></center><p>\n";

if ($debug > 0) {
    print "<p>\n";
    print "query string is: " . $ENV{QUERY_STRING} . "\n";
    print "<p>\n";
    print "i've got " . $#ARGV . " command args\n";
    for ($i = 0; $i <= $#ARGV; $i++) {
	print "<br>" . $i . ". " . @ARGV[$i] . "\n";
    }
    print "<p>\n";
    print "<pre>\n";
}
#
# parse stdin into a list of name-value pairs and stuff into hash %posts.
# this is used to support the POST method.
# stdin format is "name1=value1&name2=value2&...".
#
while ($line = <>) {
    chop $line;
    @nvpairs = split('&', $line);
    for ($i = 0; $i <= $#nvpairs; $i++) {
	@nv = split('=',@nvpairs[$i]);
	if ($#nv == 1) {
	    if ($debug > 0) {
		print @nv[0] . "  =  " . @nv[1] . "\n";
	    }
	    $posts{@nv[0]} = @nv[1];
	}
    }
};
#
# parse QUERY_STRING into nv pairs and hash them.
# this supports the GET method (which is currently used).
#
@nvpairs = split('&', $ENV{QUERY_STRING});
for ($i = 0; $i <= $#nvpairs; $i++) {
    @nv = split('=',@nvpairs[$i]);
    if ($#nv == 1) {
	if ($debug > 0) {
	    print @nv[0] . "  =  " . @nv[1] . "\n";
	}
	$posts{@nv[0]} = @nv[1];
    }
}
if ($debug > 0) {
    print "</pre>\n";
}

$msg = $posts{dedmess};
$qitem = $posts{qitem};
$showit = 0;
if ($qitem eq "") {
    $qitem = $ENV{QUERY_STRING};
    if ( -f "$q_directory/$qitem" ) {
	$msg = lookuptag("$q_directory/$qitem", "DEDICATION=");
	$showit = 1;
    } else {
	print "Sorry, there is no such request.\n";
    }
} else {
#   $msg =~ tr/+/ /;
    $msg = urldec($msg);
    $qitem = $posts{qitem};
    if ( -f "$q_directory/$qitem" ) {
	open(I, "$q_directory/$qitem");
	open(O, ">$q_directory/$qitem.tmp");
	while ($line = <I>) {
	    if ($line !~ /^DEDICATION=/) {
		print O $line;
	    }
	}
	if ($msg ne "") {
	    print O "DEDICATION=$msg\n";
	}
	close(I);
	close(O);
	rename "$q_directory/$qitem.tmp", "$q_directory/$qitem";
	$showit = 1;
    } else {
	print "Sorry, there is no such request.\n";
    }
}

if ($showit == 1) {
    print "<p><table width=90%>\n";
    print "<tr><td colspan=2><hr></td></tr>\n";
    $type = lookuptag($q_directory . "/" . $qitem, "TYPE=");
    $path = lookuptag($q_directory . "/" . $qitem, "Q=");
    $host = lookuptag($q_directory . "/" . $qitem, "HOSTNAME=");
    $dedic = lookuptag($q_directory . "/" . $qitem, "DEDICATION=");
    if ($dedic ne "") {
	$dedic = "<br><font color=gold>" . $dedic . "</font>";
    }
    if (!($host =~ /^[0-9]/)) {
	$host =~ s/\..*//;
    }
    if ($type eq "ALBUM") {
	$title = friendlyalbumtitle($path);
	$time = "TotalTime";
	$trk = lookuptag($q_directory . "/" . $qitem, "CTRACK=");
	print "<tr>\n";
	print "<td width=60%><font size=+1><b>$title</b></font>\n";
	if ($trk ne "") {
	    print "<br>&nbsp; <em>(playing track $trk)</em>";
	}
	print "</td>\n";
	print "<td>($time) $host $dedic</td>\n";
	print "</tr>\n";
    } else {
	$title = friendlytitle($path);
	$time = gettime($path);
	print "<tr>\n";
	print "<td width=60%>$title</td>\n";
	print "<td><a href=\"/cgi-bin/abouttrack.cgi?$path\">$time</a> $host $dedic</td>\n";
	print "</tr>\n";
    }
    print "<tr><td colspan=2><hr></td></tr>\n";
    print "</table>\n";

    print "<p>\n";
    print "<form action=\"/cgi-bin/tuneded.cgi\">\n";
    print "Dedication Message: ";
    print "<input type=text name=dedmess value=\"" . $msg . "\">\n";
    print "<input type=hidden name=qitem value=\"" . $qitem . "\">\n";
    print "</form>\n";
}

open(I, $tunebot_root . "/html/bodypart.html.tail");
while ($line = <I>) {
    print $line;
}
close(I);

print "</html>\n";
exit 0

